def knapsack_0_1_bnb(i, w_left, current_v, max_v, sol,
                     opt_sol, opt_v, w, v, C):
    # Проверить базовый вариант
    if i == len(sol):
        # Check if better solution has been found
        if current_v > opt_v:
            # Обновить оптимальное значение и решение
            opt_v = current_v
            for k in range(0, len(sol)):
                opt_sol[k] = sol[k]
    else:
        # Генерация кандидатов
        for k in range(0, 2):

            # Проверить, можно ли обрезать дерево рекурсии
            # в соответствии с ограничением (емкости)
            if k * w[i] <= w_left:

                # Обновить максимально возможное значение
                new_max_v = max_v - (1 - k) * v[i]

                # Проверить, можно ли обрезать дерево рекурсии
                # в соответствии с оптимальным значением
                if new_max_v > opt_v:

                    # Развернуть частичное решение
                    sol[i] = k

                    # Обновите оставшуюся емкость
                    # и частичное значение
                    new_w_left = w_left - k * w[i]
                    new_current_v = current_v + k * v[i]

                    # Попробовать развернуть частичное решение
                    opt_v = knapsack_0_1_bnb(i + 1, new_w_left,
                                             new_current_v,
                                             new_max_v, sol,
                                             opt_sol, opt_v,
                                             w, v, C)

    # Возврат оптимального решения, найденного на данный момент
    return opt_v


def knapsack_0_1_branch_and_bound_wrapper(w, v, C):
    sol = [0] * (len(w))
    opt_sol = [0] * (len(w))
    total_v = knapsack_0_1_bnb(0, C, 0, sum(v), sol,
                               opt_sol, -1, w, v, C)
    print_knapsack_solution(opt_sol, w, v, C, total_v)


def print_knapsack_solution(sol, w, v, C, opt_value):
    n = len(sol)
    k = 0
    while k < n and sol[k] == 0:
        k = k + 1

    total_weight = 0
    if k < n:
        print('(', w[k], ', ', v[k], ')', sep='', end='')
        total_weight = total_weight + w[k]

        for i in range(k + 1, n):
            if sol[i] == 1:
                total_weight = total_weight + w[i]
                print(' + ', sep='', end='')
                print('(', w[i], ', ', v[i], ')', sep='', end='')

    print(' => ', '(', total_weight,
          ', ', opt_value, ')', sep='')


w = [3, 6, 9, 5]  # Список весов объектов
v = [7, 2, 10, 4]  # Список значений объектов
C = 15  # Грузоподъемность рюкзака
knapsack_0_1_branch_and_bound_wrapper(w, v, C)
